<template>
    <div class="page-container list-container">
        <!-- 功能按钮区 -->
        <div class="list-btns-container">
            <el-button
                    type="primary"
                    size="small"
                    icon="Plus"
                    @click="handleAdd"
                    v-hasPermi="['business:lable:add']"
            >新增</el-button>

            <el-button
                    type="success"
                    size="small"
                    icon="Edit"
                    :disabled="single"
                    @click="handleUpdate"
                    v-hasPermi="['business:lable:edit']"
            >修改</el-button>

            <el-button
                    type="danger"
                    size="small"
                    icon="Delete"
                    :disabled="multiple"
                    @click="handleDelete"
                    v-hasPermi="['business:lable:remove']"
            >删除</el-button>

            <el-button
                    type="warning"
                    size="small"
                    icon="Download"
                    @click="handleExport"
                    v-hasPermi="['business:lable:export']"
            >导出</el-button>
            <!--<right-toolbar v-model:showSearch="showSearch" @queryTable="getList"></right-toolbar>-->
        </div>
        <!-- 搜索区 -->
        <el-form class="list-search-container" size="small" :model="queryParams" ref="queryRef" :inline="true" label-width="68px">
                        <el-form-item label="客户标签：" prop="lable">
                            <el-input
                                    v-model="queryParams.lable"
                                    placeholder="请输入客户标签"
                                    clearable
                                    @keyup.enter="handleQuery"
                            />
                        </el-form-item>
            <el-form-item>
                <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
                <el-button icon="Refresh" @click="resetQuery">重置</el-button>
            </el-form-item>
        </el-form>

        <!-- 列表区 -->
        <el-table v-loading="loading" :data="lableList" size="small" border height="100%" @selection-change="handleSelectionChange">
            <el-table-column type="selection" width="55" align="center" />
                    <el-table-column label="客户标签" align="center" prop="lable" />
                    <el-table-column label="添加时间" align="center" prop="createTime" />
                    <el-table-column label="备注" align="center" prop="remark" />
            <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
                <template #default="scope">
                    <el-button link type="warning" size="small" icon="Edit" @click="handleUpdate(scope.row)" v-hasPermi="['business:lable:edit']">修改</el-button>
                    <el-button link type="danger" size="small" icon="Delete" @click="handleDelete(scope.row)" v-hasPermi="['business:lable:remove']">删除</el-button>
                </template>
            </el-table-column>
        </el-table>

        <!-- 分页 -->
        <pagination v-show="total>0" :total="total" v-model:page="queryParams.pageNum" v-model:limit="queryParams.pageSize" @pagination="getList"/>

        <!-- 表单 -->
        <lable-form ref="lableRef" :get-list="getList"></lable-form>
    </div>
</template>

<script setup name="Lable">
    import { listLable, delLable } from "@/api/business/lable";
    import lableForm from "./form"
    const { proxy } = getCurrentInstance()
    /** 字典数组区 */
    /** 查询 对象 */

    const lableList = ref([]);
    const loading = ref(true);
    const ids = ref([])
    const single = ref(true);
    const multiple = ref(true);
    const total = ref(0);
    /** 查询对象 */
   const queryParams=ref({
        pageNum: 1,
        pageSize: 10,
                    lable: null,
    })

  /***********************  方法区  ****************************/

    /** 查询客户标签列表 */
   function getList() {
        loading.value = true;
        listLable(queryParams.value).then(response => {
                lableList.value = response.rows;
            total.value = response.total;
            loading.value = false;
        });
    }

    /** 搜索按钮操作 */
    function handleQuery() {
        queryParams.value.pageNum = 1;
        getList();
    }

    /** 重置按钮操作 */
    function resetQuery() {
        proxy.resetForm("queryRef");
        handleQuery();
    }

    // 多选框选中数据
    function handleSelectionChange(selection) {
        ids.value = selection.map(item => item.id);
        single.value = selection.length != 1;
        multiple.value = !selection.length;
    }

    /** 新增按钮操作 */
    function handleAdd() {
         proxy.$refs.lableRef.open()
    }

    /** 修改按钮操作 */
    function handleUpdate(row) {
        const id = row.id || ids.value
        proxy.$refs.lableRef.open(id)
    }


    /** 删除按钮操作 */
    function handleDelete(row) {
        const _ids = row.id || ids.value;
        proxy.$modal.confirm('是否确认删除选中的数据项？').then(function() {
            return delLable(_ids);
        }).then(() => {
            getList();
            proxy.$modal.msgSuccess("删除成功！");
        }).catch(() => {});
    }

    /** 导出按钮操作 */
    function handleExport() {
        proxy.download('business/lable/export', {
            ...queryParams.value
        }, `lable_${new Date().getTime()}.xlsx`)
    }

   getList();
</script>
